/* Copyright (C) 2004 - 2005  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
using System;
using j4o.lang;
using com.db4o.ext;
using com.db4o.reflect;

namespace com.db4o.test
{
	/// <summary>
	/// Summary description for StoredFieldValue.
	/// </summary>
	public class StoredFieldValue 
	{
		String foo;
		int bar;
		Atom[] atoms;
    
		public void storeOne()
		{
			foo = "foo";
			bar = 10;
			atoms = new Atom[2];
			atoms[0] = new Atom("one");
			atoms[1] = new Atom("two");
		}
    
		public void testOne()
		{
			ExtObjectContainer oc = Tester.objectContainer();
			StoredClass sc = oc.storedClass(this);
			StoredField[] sf = sc.getStoredFields();
			bool[] cases = new bool[3];
			for (int i = 0; i < sf.Length; i++) 
			{
				StoredField f = sf[i];
				if(f.getName().Equals("foo"))
				{
					Tester.ensure(f.get(this).Equals("foo"));
					ensureFieldType(f, typeof(string));
					cases[0] = true;
				}
				if(f.getName().Equals("bar"))
				{
					Tester.ensure(f.get(this).Equals(10));
					ensureFieldType(f, typeof(int));
					cases[1] = true;
				}
				if(f.getName().Equals("atoms"))
				{
					ensureFieldType(f, typeof(Atom));
					Tester.ensure(f.isArray());
					Atom[] at = (Atom[])f.get(this);
					Tester.ensure(at[0].name.Equals("one"));
					Tester.ensure(at[1].name.Equals("two"));
					cases[2] = true;
				}
			}
			for (int i = 0; i < cases.Length; i++) 
			{
				Tester.ensure(cases[i]);
			}
		}

		private static void ensureFieldType(StoredField f, Type expectedType)
		{
			ReflectClass fieldClass = f.getStoredType();
			ReflectClass expectedClass = fieldClass.reflector().forClass(Class.getClassForType(expectedType));
			Tester.ensureEquals(expectedClass, fieldClass);
		}
	}
}
